// Define your custom mixins here.
// -----------------------------------------------------------------------------

/* MEDIA QUERIES */
@mixin mq-up($query) {
  @media (min-width: $query) {
    @content;
  }
}
@mixin mq-down($query) {
  @media (max-width: $query) {
    @content;
  }
}

/* PX TO REM CONVERSION */
@function rem($pixels, $context: $base-font-size) {
  @if (unitless($pixels)) {
    $pixels: $pixels * 1px;
  }
  @if (unitless($context)) {
    $context: $context * 1px;
  }
  @return calc($pixels / $context * 1rem);
}

// TEXT STYLES
// ------------------------------------------------------------
//  -----------------------------------------------------------

@mixin S1 {
  font-size: clamp(2rem, 1.5714rem + 2.1429vw, 3.5rem);
  line-height: 1.1;
  @include mq-up($md-up) {
    font-size: clamp(3.5rem, 0.5rem + 3.3333vw, 4.5rem);
  }
}
@mixin S2 {
  font-size: clamp(1.75rem, 1.3929rem + 1.7857vw, 3rem);
  line-height: 1.1;
  @include mq-up($md-up) {
    font-size: clamp(3rem, 1.5rem + 1.6667vw, 3.5rem);
  }
}
@mixin S3 {
  font-size: clamp(1.5rem, 1.3571rem + 0.7143vw, 2rem);
  line-height: 1.1;
  @include mq-up($md-up) {
    font-size: clamp(2rem, 1.5rem + 1.6667vw, 2.75rem);
  }
}
@mixin S4 {
  font-size: clamp(1.375rem, 1.3393rem + 0.1786vw, 1.5rem);
  @include mq-up($md-up) {
    font-size: clamp(1.5rem, 0rem + 1.6667vw, 2rem);
  }
}
@mixin S5 {
  font-size: clamp(1.25rem, 1.25rem + 0vw, 1.25rem);
  @include mq-up($md-up) {
    font-size: clamp(1.25rem, 0.5rem + 0.8333vw, 1.5rem);
  }
}
@mixin S6 {
  font-size: clamp(1.125rem, 1.125rem + 0vw, 1.125rem);
  @include mq-up($md-up) {
    font-size: clamp(1.125rem, 0.75rem + 0.4167vw, 1.25rem);
  }
}

// UTILITIES
// ------------------------------------------------------------
//  -----------------------------------------------------------

/**
Use this placeholder to make an element take the full parent size
Parent element must have position set to relative
**/
@mixin parent-overlap {
  display: block;
  position: absolute;
  top: 0;
  right: 0;
  left: 0;
  bottom: 0;
  text-indent: -9999px;
  z-index: 3;
}

/**
  Layout mixins
**/

@mixin fullwidthcontent {
  width: 100vw;
  position: relative;
  left: calc(-1 * (100vw - 100%) / 2);
}

@mixin global-link {
  content: "";
  position: absolute;
  top: 0;
  left: 0;
  width: 100%;
  height: 100%;
  cursor: pointer;
  z-index: 1;
}
